package WebFlow.submitJob;

import WebFlow.*;
import WebFlow.event.*;
import org.omg.CORBA.*;
import java.util.*;
import java.io.*; 

public class jobThread implements Runnable {

String CommandLine;
String jobid="0";
private boolean completed;
private submitJobImpl caller;

    public jobThread(String CommandLine, submitJobImpl caller) {
    this.CommandLine = CommandLine;
    this.caller = caller;
    System.out.println("constructor completed");   
    }

    public void run(){

   completed=false;
   try {
     String qsub = "/usr/craysoft/nqe/bin/qsub";
     CommandLine="rsh -l pse media1.osc.edu "+qsub+" "+CommandLine;
     System.out.println("SubmitNQS:");
     System.out.println(CommandLine);
     Process p = Runtime.getRuntime().exec(CommandLine);
     InputStream is = p.getInputStream();
     InputStreamReader isr = new InputStreamReader(is);
     BufferedReader in = new BufferedReader(isr);
     String nextLine = in.readLine();
     if(nextLine==null)
     System.out.println("this application does not write to stdout");
     else
     System.out.println(nextLine);
     nextLine=in.readLine();


     if(nextLine==null) System.out.println("there is no second line!");
     else {    
           System.out.println(nextLine);
           in.close();       
           // find job id
           int id1=nextLine.indexOf("<");
           int id2=nextLine.indexOf(">");
           if(id1>-1) {
	     if(id2>-1) {
                jobid=nextLine.substring(id1+1,id2);
                System.out.println("JobId is "+jobid); 
	     }
           else System.out.println("no > character");
     } 
     else  System.out.println("no < character");
     }

     if(jobid.equals("0")) {
          p.waitFor();
     }
     else {
        boolean done=false;
        while(!done) {
	    waitForCompletion();
            try {
                  String Query = "rsh -l pse media1.osc.edu";
                  Query += " /usr/craysoft/nqe/3.3.0.15/bin/";
                  Query += "qstat "+jobid;
                  Process q = Runtime.getRuntime().exec(Query);
                  InputStream is1 = q.getInputStream();
                  InputStreamReader isr1 = new InputStreamReader(is1);
                  BufferedReader in1 = new BufferedReader(isr1);
                  String response = in1.readLine();
                  if(response==null) { done=true; is1.close(); break;} 
                  System.out.println(response);
                  response=in1.readLine();
                  if(response==null) { done=true; is1.close(); break;} 
                  System.out.println(response);
	    }
            catch (Exception e) {System.out.println("qstat error "+e);}
	}
      System.out.println("Job "+jobid+" has completed");
      caller.setJobCompleted(jobid); 
     }
   }         
     catch (Exception ex) {
     System.err.println("Error in starting the job :"+CommandLine);
     System.err.println(ex);
    }


    }

    public synchronized void waitForCompletion() {
    long howLong=5000;
    try {
      wait(howLong);
    }
    catch (Exception e) {System.out.println("cannot wait");}
    } 
   
    public String getJobId(){
     return jobid;
    }

}


